<?php

namespace App\Controllers\Admin\Equipment\Part;

use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

use App\Helpers\Equipment\Part\IpHelper;
use App\Services\Equipment\Part\IpService;

use App\Services\Equipment\Part\LineService;

class IpController extends PartController
{
    private ?LineService $_lineService = null;
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        parent::initController($request, $response, $logger);
        $this->title = lang("{$this->getService()->getClassName()}.title");
        $this->class_path .= $this->getService()->getClassName();
        $this->uri_path .= strtolower($this->getService()->getClassName('/')) . '/';
        // $this->view_path .= strtolower($this->getService()->getClassName()) . DIRECTORY_SEPARATOR;

    }
    public function getService(): IpService
    {
        if (!$this->_service) {
            $this->_service = new IpService($this->request);
        }
        return $this->_service;
    }
    public function getHelper(): IpHelper
    {
        if (!$this->_helper) {
            $this->_helper = new IpHelper($this->request);
        }
        return $this->_helper;
    }
    final public function getLineService(): LineService
    {
        if (!$this->_lineService) {
            $this->_lineService = new LineService($this->request);
        }
        return $this->_lineService;
    }
    protected function getFormFieldOption(string $field, array $options): array
    {
        switch ($field) {
            case 'lineinfo_uid':
                $temps = [];
                foreach ($this->getLineService()->getEntities() as $entity) {
                    $temps[$entity->getPK()] = $entity->getTitle();
                }
                $options[$field] = $temps;
                break;
            default:
                $options = parent::getFormFieldOption($field, $options);
                break;
        }
        return $options;
    }
    //Index,FieldForm관련
    protected function setOrderByForList()
    {
        //OrderBy 처리
        $this->getService()->getModel()->orderBy('INET_ATON(ip)', 'ASC', false);
        parent::setOrderByForList();
    }
}
